"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_redux_1 = require("react-redux");
var Context_1 = require("./Context");
var help_1 = require("../utils/help");
function createConnect() {
    return function (mapStateToProps, mapDispatchToProps, mergeProps, extraOptions) {
        if (mergeProps === void 0) { mergeProps = null; }
        if (extraOptions === void 0) { extraOptions = {}; }
        var reactReduxExtraOptions = __assign({ context: Context_1.ResaContext }, extraOptions);
        return function wrapWithConnect(WrappedComponent) {
            function ConnectFunction(props) {
                var Context = reactReduxExtraOptions.context;
                var contextValue = React.useContext(Context);
                var resa = contextValue.store.resa;
                var newMapStateToProps = React.useMemo(function () {
                    if (mapStateToProps == null) {
                        return null;
                    }
                    return function (state, ownProps) { return mapStateToProps(resa.models, state, ownProps); };
                }, []);
                var newMapDispatchToProps = React.useMemo(function () {
                    if (mapDispatchToProps == null) {
                        return null;
                    }
                    if (Array.isArray(mapDispatchToProps)) {
                        var models_1 = {};
                        mapDispatchToProps.forEach(function (namespace) {
                            var model = resa.models[namespace];
                            models_1[namespace] = model;
                        });
                        return function () { return models_1; };
                    }
                    return function (dispatch) { return mapDispatchToProps(resa.models, dispatch); };
                }, []);
                var ConnectedComponent = React.useMemo(function () {
                    return react_redux_1.connect(newMapStateToProps, newMapDispatchToProps, mergeProps, reactReduxExtraOptions)(WrappedComponent);
                }, [reactReduxExtraOptions.forwardRef, reactReduxExtraOptions.context, mergeProps]);
                var forwardedRef = props.forwardedRef, rest = __rest(props, ["forwardedRef"]);
                return React.createElement(ConnectedComponent, __assign({}, rest, { ref: forwardedRef }));
            }
            return help_1.forwardComponent(extraOptions.forwardRef, ConnectFunction, WrappedComponent, 'ResaConnect');
        };
    };
}
exports.default = createConnect;
