"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Subscription_1 = require("react-redux/lib/utils/Subscription");
var Context_1 = require("./Context");
var react_1 = require("react");
var createObservable_1 = require("../utils/createObservable");
var help_1 = require("../utils/help");
function useResa(models, dependences, Context) {
    if (models === void 0) { models = []; }
    if (dependences === void 0) { dependences = []; }
    if (Context === void 0) { Context = Context_1.default; }
    var contextValue = React.useContext(Context);
    var isInit = react_1.useRef(true);
    var modelMetas = react_1.useRef(new Array(models.length));
    var resultModels = react_1.useRef(new Array(models.length));
    var store = contextValue.store;
    var resa = store.resa;
    var _a = react_1.useReducer(function (s) { return s + 1; }, 0), forceRender = _a[1];
    var subscription = react_1.useMemo(function () { return new Subscription_1.default(store, contextValue.subscription); }, [
        store,
        contextValue.subscription,
    ]);
    var updateObservable = react_1.useCallback(function () {
        var models = resa.models;
        var returnModels = new Array(models.length);
        modelMetas.current.map(function (modelMeta, index) {
            var model = models[modelMeta.name];
            var state = model.state;
            if (modelMeta.state !== state) {
                modelMeta.state = state;
                modelMeta.observableModel = Object.assign({}, model, {
                    state: createObservable_1.default(state, modelMeta.depandenceMap),
                });
            }
            returnModels[index] = modelMeta.observableModel;
        });
        resultModels.current = returnModels;
    }, []);
    var tryRegister = react_1.useCallback(function () {
        var resaModels = resa.models;
        models.map(function (modelItem, index) {
            var instance = new modelItem();
            var namespace = instance.namespace;
            var name = namespace === '' ? instance.name : namespace + "/" + instance.name;
            var model = resaModels[name];
            if (process.env.NODE_ENV !== 'production') {
                help_1.checkModelType(instance, name, resa.modelTypeName);
            }
            if (model == null) {
                resa.register(instance);
            }
            var depandenceMap = {};
            dependences.map(function (dp) {
                depandenceMap[dp] = true;
            });
            modelMetas.current[index] = {
                name: name,
                depandenceMap: depandenceMap,
                observableModel: null,
                state: null,
            };
        });
        updateObservable();
        isInit.current = false;
    }, []);
    if (isInit.current) {
        tryRegister();
    }
    var calculateShouldUpdate = react_1.useCallback(function () {
        var models = resa.models;
        return modelMetas.current.some(function (modelMeta) {
            var model = models[modelMeta.name];
            var state = model.state;
            var prevState = modelMeta.state;
            var dMap = modelMeta.depandenceMap;
            return Object.keys(dMap).some(function (key) {
                if (state[key] !== prevState[key]) {
                    return true;
                }
                return false;
            });
        });
    }, []);
    react_1.useLayoutEffect(function () {
        var onStateChange = function () {
            var shouldUpdate = calculateShouldUpdate();
            if (shouldUpdate) {
                updateObservable();
                forceRender({});
            }
        };
        subscription.onStateChange = onStateChange;
        subscription.trySubscribe();
        return function () {
            subscription.tryUnsubscribe();
        };
    }, [store, subscription]);
    return resultModels.current;
}
exports.default = useResa;
