"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_1 = require("redux");
var redux_immutable_1 = require("redux-immutable");
var redux_saga_1 = require("redux-saga");
var invariant = require("invariant");
var effects_1 = require("redux-saga/effects");
var redux_saga_middleware_1 = require("redux-saga-middleware");
var action_1 = require("./utils/action");
var predicates_1 = require("./utils/predicates");
var combineModel_1 = require("./utils/combineModel");
var help_1 = require("./utils/help");
var ROOT_MODEL = '@@__ROOT_MODEL__@@';
var ActionTypes = {
    INIT: '@@redux/INIT',
    CANCEL_EFFECTS: '@@CANCEL_EFFECTS',
};
var noop = function () { };
var payloadEncode = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var payload = {
        __resa__payload__: true,
    };
    args.forEach(function (item, i) {
        payload[i] = item;
    });
    return payload;
};
var payloadDecode = function (payload) {
    if (payload.__resa__payload__) {
        delete payload.__resa__payload__;
        return Object.keys(payload).map(function (k) { return payload[k]; });
    }
    return payload;
};
function createResa(options) {
    var _a = options || {}, _b = _a.reducers, reducers = _b === void 0 ? {} : _b, _c = _a.errorHandle, errorHandle = _c === void 0 ? noop : _c, _d = _a.reduxDevToolOptions, reduxDevToolOptions = _d === void 0 ? {} : _d, _e = _a.initialState, initialState = _e === void 0 ? {} : _e, _f = _a.middlewares, middlewares = _f === void 0 ? [] : _f, _g = _a.remoteReduxDevtools, remoteReduxDevtools = _g === void 0 ? false : _g;
    function resaReducer(state, _action) {
        if (state === void 0) { state = {}; }
        return state;
    }
    var initReducer = __assign({}, reducers, { resaReducer: resaReducer });
    function combineReducersInner(asyncReducers, state) {
        if (predicates_1.default(state)) {
            return redux_immutable_1.combineReducers(__assign({}, asyncReducers));
        }
        return redux_1.combineReducers(__assign({}, asyncReducers));
    }
    function makeRootReducer(asyncReducers, matrixReducers) {
        var finalMatrixReducers = {};
        Object.keys(matrixReducers).map(function (key) {
            var maybeReducer = matrixReducers[key];
            if (typeof maybeReducer === 'function') {
                finalMatrixReducers[key] = maybeReducer;
            }
            else {
                finalMatrixReducers[key] = combineReducersInner(maybeReducer, {});
            }
        });
        return combineReducersInner(__assign({}, initReducer, asyncReducers, finalMatrixReducers), initialState);
    }
    function mergeImmutablePayload(state, payload) {
        if (payload === void 0) { payload = {}; }
        if (predicates_1.default(payload)) {
            return state.withMutations(function (map) {
                payload.map(function (value, key) {
                    map.set(key, value);
                    return null;
                });
            });
        }
        return state.withMutations(function (map) {
            Object.keys(payload).map(function (key) {
                map.set(key, payload[key]);
                return null;
            });
        });
    }
    function commonReducerHandle(state, payload) {
        if (payload == null) {
            return state;
        }
        if (predicates_1.default(state)) {
            return mergeImmutablePayload(state, payload);
        }
        if (Object.prototype.toString.call(state) === '[object Object]') {
            invariant(Object.prototype.toString.call(payload) === '[object Object]', 'The payload must be an object if the shape of state is object');
            return Object.assign({}, state, payload);
        }
        return payload;
    }
    function getEffectSaga(models, saga, effectName, dispatch) {
        return function (action) {
            var resolve, reject, rest, that, result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resolve = action.resolve, reject = action.reject, rest = __rest(action, ["resolve", "reject"]);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        that = Object.assign({}, models[effectName], dispatch, { models: models });
                        return [4, effects_1.call.apply(void 0, [[that, saga]].concat(payloadDecode(rest.payload)))];
                    case 2:
                        result = _a.sent();
                        resolve(result);
                        return [3, 4];
                    case 3:
                        error_1 = _a.sent();
                        errorHandle(error_1);
                        reject(error_1);
                        return [3, 4];
                    case 4: return [2];
                }
            });
        };
    }
    function getSaga(app, action, effect, effectName, dispatch) {
        var type = 'takeEvery';
        var actualEffect = effect;
        if (Array.isArray(effect)) {
            type = effect[1];
            actualEffect = effect[0];
            invariant(['takeEvery', 'takeLatest', 'throttle', 'takeFirst'].indexOf(type) > -1, 'effect type should be takeEvery, takeFirst, takeLatest or throttle.');
            if (type === 'throttle') {
                invariant(Number.isInteger(effect[2]) === true && effect[2] > 0, 'ms of throttle should be positive integer.');
            }
        }
        var effectSaga = getEffectSaga(app.models, actualEffect, effectName, dispatch);
        switch (type) {
            case 'takeFirst':
                return function () {
                    var at;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!true) return [3, 3];
                                return [4, effects_1.take(action.pending)];
                            case 1:
                                at = _a.sent();
                                return [4, effects_1.call(effectSaga, at)];
                            case 2:
                                _a.sent();
                                return [3, 0];
                            case 3: return [2];
                        }
                    });
                };
            case 'takeLatest':
                return function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, effects_1.takeLatest(action.pending, effectSaga)];
                            case 1:
                                _a.sent();
                                return [2];
                        }
                    });
                };
            case 'throttle':
                return function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, effects_1.throttle(effect[2], action.pending, effectSaga)];
                            case 1:
                                _a.sent();
                                return [2];
                        }
                    });
                };
            default:
                return function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, effects_1.takeEvery(action.pending, effectSaga)];
                            case 1:
                                _a.sent();
                                return [2];
                        }
                    });
                };
        }
    }
    function runSagaAndReturnActionCreators(model, app, namespace) {
        if (namespace === void 0) { namespace = ''; }
        var actions = {};
        var store = app.store, runSaga = app.runSaga;
        var newEffects = {};
        var oldEffects = model.effects || {};
        var effectName = namespace === '' ? model.name : namespace + "/" + model.name;
        var _loop_1 = function (key) {
            if (Object.prototype.hasOwnProperty.call(oldEffects, key)) {
                var action_2 = action_1.createAction(effectName + "/" + key);
                var innerReducer = function (state, action) {
                    try {
                        return commonReducerHandle(state, action.payload);
                    }
                    catch (error) {
                        errorHandle(error);
                        return state;
                    }
                };
                actions[action_2.fulfilled] = innerReducer;
                var dispatch_1 = {
                    fulfilled: function (obj) {
                        store.dispatch(action_2.fulfilled(obj));
                    },
                };
                newEffects[key] = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    return store.dispatch(action_2.pending(payloadEncode.apply(void 0, args)));
                };
                runSaga(function () {
                    var saga, task;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                saga = getSaga(app, action_2, oldEffects[key], effectName, dispatch_1);
                                return [4, effects_1.fork(saga)];
                            case 1:
                                task = _a.sent();
                                return [4, effects_1.fork(function () {
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4, effects_1.take(effectName + "/" + ActionTypes.CANCEL_EFFECTS)];
                                                case 1:
                                                    _a.sent();
                                                    return [4, effects_1.cancel(task)];
                                                case 2:
                                                    _a.sent();
                                                    return [2];
                                            }
                                        });
                                    })];
                            case 2:
                                _a.sent();
                                return [2];
                        }
                    });
                });
            }
        };
        for (var key in oldEffects) {
            _loop_1(key);
        }
        var newReducers = {};
        var oldReducers = model.reducers || {};
        var _loop_2 = function (key) {
            if (Object.prototype.hasOwnProperty.call(oldReducers, key)) {
                actions[effectName + "/" + key] = function (state, _a) {
                    var payload = _a.payload;
                    var _b;
                    var that = {
                        state: state,
                    };
                    var particalState = (_b = oldReducers[key]).call.apply(_b, [that].concat(payloadDecode(payload)));
                    return commonReducerHandle(state, particalState);
                };
                newReducers[key] = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    store.dispatch({
                        type: effectName + "/" + key,
                        payload: payloadEncode.apply(void 0, args),
                    });
                };
            }
        };
        for (var key in oldReducers) {
            _loop_2(key);
        }
        var oldPureReducers = model.pureReducers || {};
        for (var key in oldPureReducers) {
            if (Object.prototype.hasOwnProperty.call(oldPureReducers, key)) {
                actions[key] = oldPureReducers[key];
            }
        }
        return {
            actions: actions,
            actionCreaters: __assign({}, newEffects, newReducers),
        };
    }
    function checkModel(model, app, namespace) {
        if (namespace === void 0) { namespace = ''; }
        invariant(typeof model.name === 'string' && model.name !== '', "name of model should be non empty string, but got " + typeof model.name);
        if (namespace !== '') {
            invariant(app.models[namespace + "/" + model.name] == null, "namespace/name of model should be unique, please check model namespace/name: " + namespace + "/" + model.name);
            invariant(typeof app.store.matrixReducers[namespace] !== 'function', "namespace should be different of model name, please check namespace: " + namespace);
        }
        else {
            invariant(app.models[model.name] == null, "name of model should be unique, please check model name: " + model.name);
            invariant(app.store.matrixReducers[model.name] == null, "name of model should be different of exist model name or exist namespace, please check model name: " + model.name);
        }
        invariant(model.state != null, 'State in model should not be null or undefined.');
    }
    function mountModel(app, name, actionCreaters, getState, isRoot) {
        if (isRoot === void 0) { isRoot = false; }
        var _a;
        app.models[name] = __assign({}, actionCreaters, (_a = { name: name }, _a[ROOT_MODEL] = isRoot, _a));
        Object.defineProperty(app.models[name], 'state', {
            enumerable: true,
            configurable: false,
            get: getState,
        });
    }
    function registerCombineModel(combineModel, app, getState) {
        var _this = this;
        var _a = combineModel.models, models = _a === void 0 ? [] : _a, state = combineModel.state;
        var rs = {};
        models.forEach(function (model) {
            checkModel(model, app);
            var getModelState = help_1.getStateDelegate(state, getState, model.name);
            if (model[combineModel_1.COMBINED_RESA_MODEL]) {
                _this.models[model.name] = Object.assign({}, model);
                rs[model.name] = registerCombineModel(model, app, getModelState);
                return;
            }
            var _a = runSagaAndReturnActionCreators(model, app), actions = _a.actions, actionCreaters = _a.actionCreaters;
            rs[model.name] = action_1.handleActions(actions, help_1.cloneState(model.state));
            mountModel(app, model.name, actionCreaters, getModelState);
        });
        return combineReducersInner(rs, help_1.cloneState(state));
    }
    function registerModel(model) {
        var _a;
        var app = this;
        if (process.env.NODE_ENV !== 'production') {
            checkModel(model, app);
        }
        var store = app.store;
        var name = model.name;
        var getState = help_1.getStateDelegate(initialState, app.store.getState, name);
        if (model[combineModel_1.COMBINED_RESA_MODEL]) {
            this.models[model.name] = Object.assign({}, model, (_a = {},
                _a[ROOT_MODEL] = true,
                _a));
            var action = registerCombineModel(model, app, getState);
            store.asyncReducers[name] = action;
            store.replaceReducer(makeRootReducer(store.asyncReducers, store.matrixReducers));
            return;
        }
        var _b = runSagaAndReturnActionCreators(model, app), actions = _b.actions, actionCreaters = _b.actionCreaters;
        var state = help_1.cloneState(model.state);
        store.asyncReducers[name] = action_1.handleActions(actions, state);
        store.replaceReducer(makeRootReducer(store.asyncReducers, store.matrixReducers));
        mountModel(app, name, actionCreaters, getState, true);
    }
    function register(model, newNamespace) {
        var app = this;
        var store = app.store;
        var name = model.name;
        var namespace = newNamespace || model.namespace;
        if (process.env.NODE_ENV !== 'production') {
            checkModel(model, app, namespace);
        }
        var _a = runSagaAndReturnActionCreators(model, app, namespace), actions = _a.actions, actionCreaters = _a.actionCreaters;
        var state = help_1.cloneState(model.state);
        if (namespace === '') {
            var getState = help_1.getStateDelegate(initialState, app.store.getState, name);
            store.matrixReducers[name] = action_1.handleActions(actions, state);
            mountModel(app, name, actionCreaters, getState, true);
        }
        else {
            var namespaceReducer = store.matrixReducers[namespace] || {};
            store.matrixReducers[namespace] = namespaceReducer;
            namespaceReducer[name] = action_1.handleActions(actions, state);
            var getState = help_1.getStateDelegate(initialState, app.store.getState, namespace);
            getState = help_1.getStateDelegate({}, getState, name);
            mountModel(app, namespace + "/" + name, actionCreaters, getState, false);
        }
        store.replaceReducer(makeRootReducer(store.asyncReducers, store.matrixReducers));
    }
    function unReg(app, model) {
        if (app.models[model.name]) {
            app.store.dispatch({ type: model.name + "/" + ActionTypes.CANCEL_EFFECTS });
            delete app.models[model.name];
        }
    }
    function unRegisterModel(model, shoudCheckRoot) {
        var _this = this;
        if (shoudCheckRoot === void 0) { shoudCheckRoot = true; }
        invariant(typeof model.name === 'string' && model.name !== '', "name of model should be non empty string, but got " + typeof model.name);
        var transformedModel = this.models[model.name];
        invariant(transformedModel != null, 'should not unRegister unRegistered model');
        if (shoudCheckRoot) {
            invariant(transformedModel[ROOT_MODEL], 'should only unRegister root model');
        }
        if (transformedModel[combineModel_1.COMBINED_RESA_MODEL]) {
            var _a = transformedModel.models, models = _a === void 0 ? [] : _a;
            delete this.models[transformedModel.name];
            models.forEach(function (m) {
                _this.unRegisterModel(m, false);
            });
        }
        else {
            unReg(this, transformedModel);
        }
    }
    var app = {
        store: null,
        runSaga: null,
        models: {},
        modelTypeName: {},
        registerModel: registerModel,
        unRegisterModel: unRegisterModel,
    };
    var sagaMiddleware = redux_saga_1.default();
    var finalMiddlewares = middlewares.concat(sagaMiddleware, redux_saga_middleware_1.reduxSagaMiddleware);
    if (process.env.NODE_ENV !== 'production') {
        if (window.__REDUX_DEVTOOLS_EXTENSION__) {
            finalMiddlewares = redux_1.compose(redux_1.applyMiddleware.apply(void 0, finalMiddlewares), window.__REDUX_DEVTOOLS_EXTENSION__(reduxDevToolOptions));
        }
        else {
            if (remoteReduxDevtools) {
                var composeWithDevTools = require('remote-redux-devtools').composeWithDevTools;
                var composeEnhancers = composeWithDevTools(reduxDevToolOptions);
                finalMiddlewares = composeEnhancers(redux_1.applyMiddleware.apply(void 0, finalMiddlewares));
            }
            else {
                finalMiddlewares = redux_1.applyMiddleware.apply(void 0, finalMiddlewares);
            }
        }
    }
    else {
        finalMiddlewares = redux_1.applyMiddleware.apply(void 0, finalMiddlewares);
    }
    app.store = redux_1.createStore(makeRootReducer({}, {}), initialState, finalMiddlewares);
    app.store.asyncReducers = {};
    app.store.matrixReducers = {};
    app.register = register.bind(app);
    app.registerModel = registerModel.bind(app);
    app.unRegisterModel = unRegisterModel.bind(app);
    app.runSaga = sagaMiddleware.run;
    return app;
}
exports.default = createResa;
